"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const index_1 = require("./index");
const internals_1 = require("../internals");
function updateTree(callback, tree) {
    var newTree;
    var immutable = core_1.isImmutable(tree._owner) ? (newTree = internals_1.cloneAsMutable(tree), true) : (newTree = tree, false);
    newTree = callback(newTree) || newTree;
    return immutable && !index_1.isEqual(tree, newTree) ? internals_1.doneMutating(newTree) : tree;
}
exports.updateTree = updateTree;
function update(callback, key, tree) {
    var node = internals_1.findNodeByKey(key, tree);
    var oldValue = core_1.isDefined(node) ? node.value : void 0;
    var newValue = callback(oldValue);
    if (core_1.isEqual(oldValue, newValue))
        return tree;
    if (core_1.isDefined(newValue)) {
        tree = index_1.set(key, newValue, tree);
    }
    else {
        tree = index_1.remove(key, tree);
    }
    return tree;
}
exports.update = update;

//# sourceMappingURL=update.js.map
